unit ChWpCommon; interface
uses {ShlObj, ComObj, }Windows, Messages, SysUtils, Classes, IniFiles, Registry;

const
  smcAuto = 'AUTO';

type
  TStartingMode = ( smUnknown, smInteractive, smAuto, smChange);
  TWChangeMethod = ( wcmSerial, wcmRandom);

  TWpOptions = record
    WallpapersDir : string;
    CurrentWalpaper : string;
    ChangeMethod : TWChangeMethod;
    end;


const
  StartingMode : TStartingMode = smUnknown;

var
  WpExeDir : string;
  WpOptions : TWpOptions;
  WpAutoFileName : string;


function ChangeWallpaper( FN : string) : string;

{ Return System folders location
  Folder can be 'Desktop', 'Start Menu' or other system filder name }
function ShellFolderDir( Folder : string) : string;

function AutochangeWallpaper : string;

procedure GetWallpapersList( Dir : string; SL : TStrings);

procedure ReadOptions;
procedure WriteOptions;

implementation

function ChangeWallpaper( FN : string) : string;
var WP : string;
begin
  Result := 'Can''t find : ' +  FN;
  if NOT FileExists( FN) then exit;
  WP := FN + #0;
  SystemParametersInfo(SPI_SETDESKWALLPAPER,0,PChar( WP),SPIF_UPDATEINIFILE);
  SendMessage( HWND_BROADCAST,WM_SETTINGCHANGE,0,0);
  Result := '';
end;

function ShellFolderDir( Folder : string) : string;
var MyReg     : TRegIniFile;
begin
  MyReg := TRegIniFile.Create(
           'Software\MicroSoft\Windows\CurrentVersion\Explorer');
  Result := MyReg.ReadString('Shell Folders', Folder,'');
  MyReg.Free;
end;

procedure GetWallpapersList( Dir : string; SL : TStrings);
var SR : TSearchRec; I : integer;
begin
  if Dir[ Length( Dir)] <> '\' then Dir := Dir + '\';
  if FindFirst( Dir + '*.bmp', faAnyFile, SR) = 0 then begin
    SL.Clear;
    repeat
      SL.Add( Dir + SR.Name);
    until FindNext( SR) <> 0;
    end;
end;

function AutochangeWallpaper : string;
var WpSL : TStringList; WI : integer;

  function GetWallpaperIndex( CurrWI : integer) : integer;
  begin
    Result := 0;
    if CurrWI < 0 then exit;
    case WpOptions.ChangeMethod of
      wcmSerial : begin
        if CurrWI = WpSL.Count-1 then Result := 0 else Result := CurrWI + 1;
        end;
      wcmRandom : begin
        Result := Random( WpSL.Count-1)
        end;
      else Result := CurrWI;
      end;
  end;

begin
  Result := '';
  WpSL := TStringList.Create;
  try
    WpSL.Sorted := true;
    GetWallpapersList( WpOptions.WallpapersDir, WpSL);
    if WpSL.Count > 0 then begin
      if WpOptions.CurrentWalpaper <> '' then begin
        if WpSL.Find( WpOptions.CurrentWalpaper, WI) then
             WI := GetWallpaperIndex( WI)
        else WI := GetWallpaperIndex( 0);
        end { WpOptions.CurrentWalpaper <> ''}
      else WI := 0;
      WpOptions.CurrentWalpaper := WpSL.Strings[ WI];
      Result := ChangeWallpaper( WpOptions.CurrentWalpaper);
      if Result = '' then WriteOptions;
      end { WpSL.Count > 0}
    else begin
      Result := 'Can''t find Wallpapers directory OR no wallpapers in the directory';
      end;
  finally WpSL.Free; end;
end;

const
  WpIniFileName = 'cwp.ini';
  secGeneral = 'General';
  optWpDir = 'WDir';
  optWpCur = 'WCur';
  optWpChM = 'WChM';

procedure ReadOptions;
var IniFile : TIniFile;
begin
  IniFile:= TIniFile.Create( WpExeDir + '\' + WpIniFileName);
  try with IniFile, WpOptions do begin
    WallpapersDir :=  ReadString( secGeneral, optWpDir, WpExeDir);
    CurrentWalpaper := ReadString( secGeneral, optWpCur, '');
    ChangeMethod := TWChangeMethod( ReadInteger( secGeneral, optWpChM, 0));
    end;
  finally
    IniFile.Free;
    end;
end;

procedure WriteOptions;
var IniFile : TIniFile;
begin
  IniFile:= TIniFile.Create( WpExeDir + '\' + WpIniFileName);
  try with IniFile, WpOptions do begin
    WriteString( secGeneral, optWpDir, WallpapersDir);
    WriteString( secGeneral, optWpCur, CurrentWalpaper);
    WriteInteger( secGeneral, optWpChM, ord( ChangeMethod));
    end;
  finally
    IniFile.Free;
    end;
end;

var
  PCou : integer;
  ParStr : string;

initialization
  Randomize;
  WpExeDir := ExtractFilePath( Paramstr( 0));
  if ParamCount > 0 then begin
    ParStr := Trim( ParamStr(1));
    if UpperCase( ParStr) = smcAuto then StartingMode := smAuto
    else begin
      WpAutoFileName := ParStr;
      StartingMode := smChange;
      end;
    end
  else StartingMode := smInteractive;
  ReadOptions;
  if NOT FileExists( WpExeDir + '\' + WpIniFileName) then WriteOptions;
end.
